; */////////////////////////////////////////////*
; *//  Mech Clash Version 1.0                 //*
; *//  Written By Eikon                       //*
; */////////////////////////////////////////////*

Graphics 400, 300, 16, 1
AppTitle "Mech Clash v1.0 by Eikon"
SetBuffer BackBuffer()
SeedRnd(MilliSecs())

; *///////////////// Graphics \\\\\\\\\\\\\\\\\*
Global Mech = LoadAnimImage("mech.png", 44, 44, 0, 16)
Global Logo = LoadImage("logo.png")
Global WeapSel = LoadImage("weapsel.png")
Global Shot = LoadImage("bullet.png")
Global Flame = LoadImage("flame.png")
Global Mech2 = LoadAnimImage("mech2.png", 44, 44, 0, 16)
Global Back2 = LoadImage("back.png")
Global Sword = LoadAnimImage("sword.png", 95, 68, 0, 14)
Global Sword2 = LoadAnimImage("sword.png", 95, 68, 0, 14)

MaskImage WeapSel, 255, 0, 255
MaskImage Back2, 255, 0, 255

; *///////////////// Sound FX \\\\\\\\\\\\\\\\\*
ShotgunSFX = LoadSound("fire.wav")
FlameSFX = LoadSound("flame.wav")
BoostSFX = LoadSound("boost.wav")
IntroSFX = LoadSound("arnold.wav")
DestroySFX = LoadSound("destroyed.wav")
SwordSFX = LoadSound("slash.wav")
Global Sword2SFX = LoadSound("slash2.wav")
ShieldON = LoadSound("shieldon.wav")
ShieldOFF = LoadSound("shieldoff.wav")
ArnoldSFX = LoadSound("arnold.wav")

; *///////////////// Variables \\\\\\\\\\\\\\\\\*
Global P1X = 70, P1Y = 217, P1D = 1, P1Frame = 0
Global P2X = 270, P2Y = 217, P2D = 0, P2Frame = 9
Global X2 = 0, J2 = 0, J2D = 0
Global X4 = 200, X5 = 0
Global P1P = 50, P2P = 270
Global X = 200, J = 0, JD = 0
Global View = 1
Global P1S = 1, SV1# = 255
Global P2S = 1, SV2# = 255
Global Timer = MilliSecs()
Global Press1 = 0
Global Press2 = 0
Global P1Life# = 100
Global P2Life# = 100
Global Winner = 0
Global BP = 100, BD = 0, Boosting = 0
Global Bp2 = 100, BD2 = 1, Boosting2 = 0
Global UsingSword1 = 0, UsingSword2 = 0
Global BulletTime1 = MilliSecs()
Global BulletTime2 = MilliSecs()
Global P1Weap1 = 0, P1Weap2 = 0
Global P2Weap1 = 0, P2Weap2 = 0
Global CurrentWeap1 = 1, CurrentWeap2 = 1

; *///////////////// Types \\\\\\\\\\\\\\\\\*
Type Bullet
	Field X
	Field Y
	Field D
	Field C
	Field Angle
	Field Src
	Field Frame
End Type

Type Particle
	Field X
	Field Y
	Field C
	Field L
End Type

HidePointer

; *///////////////// Font \\\\\\\\\\\\\\\\\*
Font = LoadFont("Arial", 12, 12, False, False)
SetFont Font

; *///////////////// Title Screen \\\\\\\\\\\\\\\\\*
.Reset
Channel = PlaySound(ArnoldSFX)
SetBuffer FrontBuffer()
.Title
Cls
DrawImage WeapSel, 0, 0
Random = Input("Random (0/1)? ")
If Random = 1 Then
	
	While P1Weap1 = P1Weap2
    	P1Weap1 = Rand(1, 5)
		P1Weap2 = Rand(1, 5)
		If P1Weap1 = 2 Then P1Weap1 = 3
		If P1Weap2 = 2 Then P1Weap2 = 3
		
		If P1Weap1 = 4 Then P1Weap1 = 5
		If P1Weap2 = 4 Then P1Weap2 = 5
	Wend
	
	If P1Weap1 = 3 Or P1Weap2 = 3 Then
		SwCo1 = Rand(1, 3)
		If SwCo1 = 1 Then Sword = LoadAnimImage("sword.png", 95, 68, 0, 14)
		If SwCo1 = 2 Then Sword = LoadAnimImage("sword2.png", 95, 68, 0, 14)
		If SwCo1 = 3 Then Sword = LoadAnimImage("sword3.png", 95, 68, 0, 14)
	EndIf

	While P2Weap1 = P2Weap2
    	P2Weap1 = Rand(2, 6)
		P2Weap2 = Rand(2, 6)
		If P2Weap1 = 3 Then P2Weap1 = 4
		If P2Weap2 = 3 Then P2Weap2 = 4
		
		If P2Weap1 = 5 Then P2Weap1 = 6
		If P2Weap2 = 5 Then P2Weap2 = 6
	Wend
	
	If P2Weap1 = 3 Or P2Weap2 = 3 Then
		SwCo2 = Rand(1, 3)
		If SwCo2 = 1 Then Sword2 = LoadAnimImage("sword.png", 95, 68, 0, 14)
		If SwCo2 = 2 Then Sword2 = LoadAnimImage("sword2.png", 95, 68, 0, 14)
		If SwCo2 = 3 Then Sword2 = LoadAnimImage("sword3.png", 95, 68, 0, 14)
	EndIf
	
	Goto Moveon
EndIf
	
P1Weap1 = Input("1, 3, or 5: ")
P1Weap2 = Input("1, 3, or 5: ")
If P1Weap1 = 3 Or P1Weap2 = 3 Then 
	SwCo1 = Input("Sword Color: 1, 2, or 3: ")
	If SwCo1 = 1 Then Sword = LoadAnimImage("sword.png", 95, 68, 0, 14)
	If SwCo1 = 2 Then Sword = LoadAnimImage("sword2.png", 95, 68, 0, 14)
	If SwCo1 = 3 Then Sword = LoadAnimImage("sword3.png", 95, 68, 0, 14)
EndIf
	
P2Weap1 = Input("2, 4, or 6: ")
P2Weap2 = Input("2, 4, or 6: ")
If P2Weap1 = 4 Or P2Weap2 = 4 Then 
	SwCo2 = Input("Sword Color: 1, 2, or 3: ")
	If SwCo2 = 1 Then Sword2 = LoadAnimImage("sword.png", 95, 68, 0, 14)
	If SwCo2 = 2 Then Sword2 = LoadAnimImage("sword2.png", 95, 68, 0, 14)
	If SwCo2 = 3 Then Sword2 = LoadAnimImage("sword3.png", 95, 68, 0, 14)
EndIf

.Moveon
Font = LoadFont("FixedSys", 12, 12, False, False)
SetFont Font
; *///////////////// Main \\\\\\\\\\\\\\\\\*
SetBuffer BackBuffer()
StopChannel Channel 
Channel = PlayMusic("horror.mod")
.Game
X2 = X2 + 770
P1P = P1P - 770
X5 = X5 - 384
P2P = P2P + 384
While Not KeyDown(1)
.Main
If MilliSecs() >= Timer + 80 Then Goto Render Else Goto Main
.Render
Timer = MilliSecs()
Color 0, 255, 0

If View = 1 Then
Viewport 0,0, 200, 300
TileImage Back2, X2, 0
DrawImage Mech, P1X, P1Y, P1Frame
RenderBullet()
RenderParticle()
Color 0, 0, 0: Rect 200 - 10, 1, 10, 300

Color 0, 128, 255: Rect 1, 17, BP, 10, 1
Color 255, 255, 255: Text 1, 1, "Life: " + Int(Float(P1Life))
Rect 1, 16, 101, 11, 0

If P2S = 0 Then Color 0, SV2, 0: Oval P2X, P2Y, 44, 44, 0
If P1S = 0 Then Color 0, Sv1, 0: Oval P1X, P1Y, 44, 44, 0

Viewport 200, 0, 200, 300
TileImage Back2, X5, 0
DrawImage Mech2, P2X, P2Y, P2Frame

Color 0, 0, 0: Rect 200 - 10, 1, 10, 300

Color 0, 128, 255: Rect 298, 17, BP2, 10, 1
Color 255, 255, 255: Text 298, 1, "Life: " + Int(Float(P2Life))
Rect 298, 16, 101, 11, 0

If P2S = 0 Then Color 0, SV2, 0: Oval P2X, P2Y, 44, 44, 0
If P1S = 0 Then Color 0, SV1, 0: Oval P1X, P1Y, 44, 44, 0

RenderBullet()
RenderParticle()
EndIf

If P1Life <= 0 Then PlaySound DestroySFX: Winner = 2: Goto Over
If P2Life <= 0 Then PlaySound DestroySFX: Winner = 1: Goto Over

If View = 0 Then
Viewport 0, 0, 400, 300
TileImage Back2, X2, 0
DrawImage Mech, P1X, P1Y, P1Frame
DrawImage Mech2, P2X, P2Y, P2Frame

Color 0, 128, 255: Rect 1, 17, BP, 10, 1
Color 255, 255, 255: Text 1, 1, "Life: " + Int(Float(P1Life))
Rect 1, 16, 101, 11, 0

Color 0, 128, 255: Rect 298, 17, BP2, 10, 1
Color 255, 255, 255: Text 298, 1, "Life: " + Int(Float(P2Life))
Rect 298, 16, 101, 11, 0

If P2S = 0 Then Color 0, SV2, 0: Oval P2X, P2Y, 44, 44, 0
If P1S = 0 Then Color 0, SV1, 0: Oval P1X, P1Y, 44, 44, 0
RenderBullet()
RenderParticle()
EndIf

If P2Frame = 7 And P2D = 1 Then P2Frame = 0
If P2Frame = 8 And P2D = 0 Then P2Frame = 15

If P1Frame = 7 And P1D = 1 Then P1Frame = 0
If P1Frame = 8 And P1D = 0 Then P1Frame = 15


If View = 1
; Player 1
If KeyDown(205) Then 
If P1D = 0 Then P1Frame = 0
P1D = 1
X2 = X2 - 8
P1P = P1P + 8
x = x - 1
Press = 1
P1Frame = P1Frame + 1
EndIf

If KeyDown(203) Then 
If P1D = 1 Then P1Frame = 15
P1D = 0
X2 = X2 + 8
P1P = P1P - 8
x = x + 1
Press = 1
P1Frame = P1Frame - 1
EndIf

;Player 2
If JoyX() > 0.9 And JoyX() <= 1 Then 
If P2D = 0 Then P2Frame = 0
P2D = 1
P2P = P2P + 8
x4 = x4 - 1
x5 = x5 - 8
Press = 1
P2Frame = P2Frame + 1
EndIf

If JoyX() < -0.9 And JoyX() >= -1 Then  
If P2D = 1 Then P2Frame = 15
P2D = 0
x4 = x4 + 1
x5 = x5 + 8
P2P = P2P - 8 
Press = 1
P2Frame = P2Frame - 1
EndIf
EndIf

If View = 0
If KeyDown(205) Then 
If P1D = 0 Then P1Frame = 0
P1D = 1
P1X = P1X + 8
press = 1
P1Frame = P1Frame + 1
EndIf

If KeyDown(203) Then 
If P1D = 1 Then P1Frame = 15
P1D = 0
P1X = P1X - 8
press = 1
P1Frame = P1Frame - 1
EndIf

If JoyX() > 0.9 And JoyX() <= 1 Then
If P2D = 0 Then P2Frame = 0
P2D = 1
P2X = P2X + 8
press = 1
P2Frame = P2Frame + 1
EndIf

If JoyX() < -0.9 And JoyX() >= -1 Then  
If P2D = 1 Then P2Frame = 15
P2D = 0
P2X = P2X - 8
press = 1
P2Frame = P2Frame - 1
EndIf
EndIf

If X5 <= -456 Then X5 = -456
If X2 >= 816 Then X2 = 816

.Update
If Press = 0 Then 
If P1D = 0 Then P1Frame = 15
If P1D = 1 Then P1Frame = 0
If P2D = 0 Then P2Frame = 15
If P2D = 1 Then P2Frame = 0
EndIf
Press = 0

; */////////////// Split Screen Setup \\\\\\\\\\\\\\\*

; Single Screen
If View = 1 And P1P > P2P - 210 Then View = 0
If View = 1 And P2P < P1P + 210 Then View = 0
; Borders
If View = 0 And P1X >= 400 - 44 Then P1X = 400 - 44
If View = 0 And P2X <= 0 Then P2X = 0

If View = 0 And P1X <= 0 Then P1X = 0
If View = 0 And P2X >= 400 - 44 Then P2X = 400 - 44

If Boosting = 1 Then Boost(1)
If Boosting2 = 1 Then Boost(2)
If boosting2 = 0 Then BP2 = Bp2 + 5: If bp2 > 100 Then Bp2 = 100
If Boosting = 0 Then BP = BP + 5: If BP >= 100 Then Bp = 100

If KeyHit(200) And BP > 0 Then PlaySound BoostSFX: BD = 0: Boost(1): Boosting = 1
If JoyHit(2) And BP2 > 0 Then PlaySound BoostSFX: BD2 = 0: Boost(2): Boosting2 = 1


; Player 1 Weapon Select
If KeyHit(77) Then
	If CurrentWeap1 = 1 Then CurrentWeap1 = 2: Goto Leave
	If CurrentWeap1 = 2 Then CurrentWeap1 = 1: Goto Leave
EndIf
	
If P1Weap1 = 5 And CurrentWeap1 = 1 Then
; Flame Thrower
	If KeyDown(81) And View = 0 Then 
 		If ChannelPlaying(FlameChannel) = 1 Then CreateBullet(3)
        If ChannelPlaying(FlameChannel) = 0 Then 
			For n.Bullet = Each Bullet
				If n\Src = 3 Then Delete N
			Next
		FlameChannel = PlaySound(FlameSFX)
		EndIf
	EndIf

	If Not KeyDown(81) And ChannelPlaying(FlameChannel) = 1 Then StopChannel FlameChannel: FlameChannel = 0

EndIf

If P1Weap2 = 5 And CurrentWeap1 = 2 Then
; Flame Thrower
	If KeyDown(81) And View = 0 Then 
 		If ChannelPlaying(FlameChannel) = 1 Then CreateBullet(3)
        If ChannelPlaying(FlameChannel) = 0 Then 
			For n.Bullet = Each Bullet
				If n\Src = 3 Then Delete N
			Next
		FlameChannel = PlaySound(FlameSFX)
		EndIf
	EndIf

	If Not KeyDown(81) And ChannelPlaying(FlameChannel) = 1 Then StopChannel FlameChannel: FlameChannel = 0

EndIf

; Spread
If P1Weap1 = 1 And CurrentWeap1 = 1 Then
	If KeyDown(81) And View = 0 And MilliSecs() > BulletTime1 + 300 Then CreateBullet(1): PlaySound ShotgunSFX
EndIf

If P1Weap2 = 1 And CurrentWeap1 = 2 Then
	If KeyDown(81) And View = 0 And MilliSecs() > BulletTime1 + 300 Then CreateBullet(1): PlaySound ShotgunSFX
EndIf

; Sword
If P1Weap1 = 3 And CurrentWeap1 = 1 Then
	If KeyDown(81) And View = 0 And UsingSword1 = 0 Then CreateBullet(5): PlaySound SwordSFX
EndIf

If P1Weap2 = 3 And CurrentWeap1 = 2 Then
	If KeyDown(81) And View = 0 And UsingSword1 = 0 Then CreateBullet(5): PlaySound SwordSFX
EndIf

; Player 2 Weapon Select
If JoyHit(4) Then
	If CurrentWeap2 = 1 Then CurrentWeap2 = 2: Goto Leave
	If CurrentWeap2 = 2 Then CurrentWeap2 = 1: Goto Leave
EndIf

If P2Weap1 = 6 And CurrentWeap2 = 1 Then	

If JoyDown(1) And View = 0 Then
	If ChannelPlaying(FlameChannel2) = 1 Then CreateBullet(4)
    If ChannelPlaying(FlameChannel2) = 0 Then 
		For n.Bullet = Each Bullet
			If n\Src = 4 Then Delete N
		Next
	FlameChannel2 = PlaySound(FlameSFX)
	EndIf
	
	If Not JoyDown(1) And ChannelPlaying(FlameChannel2) = 1 Then StopChannel FlameChannel2: FlameChannel2 = 0
	EndIf
EndIf

If P2Weap2 = 6 And CurrentWeap2 = 2 Then	

If JoyDown(1) And View = 0 Then
	If ChannelPlaying(FlameChannel2) = 1 Then CreateBullet(4)
    If ChannelPlaying(FlameChannel2) = 0 Then 
		For n.Bullet = Each Bullet
			If n\Src = 4 Then Delete N
		Next
	FlameChannel2 = PlaySound(FlameSFX)
	EndIf
	
	If Not JoyDown(1) And ChannelPlaying(FlameChannel2) = 1 Then StopChannel FlameChannel2: FlameChannel2 = 0
	EndIf
EndIf

If P2Weap1 = 2 And CurrentWeap2 = 1 Then
	If JoyDown(1) And View = 0 And MilliSecs() > BulletTime2 + 300 Then CreateBullet(2): PlaySound ShotgunSFX
EndIf

If P2Weap2 = 2 And CurrentWeap2 = 2 Then
	If JoyDown(1) And View = 0 And MilliSecs() > BulletTime2 + 300 Then CreateBullet(2): PlaySound ShotgunSFX
EndIf

If P2Weap1 = 4 And CurrentWeap2 = 1
	If JoyDown(1) And View = 0 And UsingSword2 = 0 Then CreateBullet(6): PlaySound SwordSFX
EndIf

If P2Weap2 = 4 And CurrentWeap2 = 2
	If JoyDown(1) And View = 0 And UsingSword2 = 0 Then CreateBullet(6): PlaySound SwordSFX
EndIf

If JoyHit(3) And P2S = 1 Then P2S = 0: PlaySound ShieldOn
If KeyHit(79) And P1S = 1 Then P1S = 0: PlaySound ShieldOn

If SV1 < 10 Then P1S = 3: SV1 = 255: PlaySound ShieldOFF
If SV2 < 10 Then P2S = 3: SV2 = 255: PlaySound ShieldOff

.Leave
Flip
Wend
Unload()

; *///////////////// Functions \\\\\\\\\\\\\\\\\*
Function CreateBullet(Src)
	; Shotgun Player 1
	If Src = 1 Then
		Angle = 1
		For I = 1 To 3
			n.Bullet = New Bullet
			n\Angle = Angle
			If P1D = 0 Then n\X = P1X - 5: n\D = 0
			If P1D = 1 Then n\X = P1X + 30: n\D = 1
			n\Y = P1Y + 13
			n\Src = 1
			Angle = Angle + 1
		Next
		BulletTime1 = MilliSecs()
	EndIf
	
	; Shotgun Player 2
	If Src = 2 Then
		Angle = 1
		For I = 1 To 3
			n.Bullet = New Bullet
			n\Angle = Angle
			If P2D = 0 Then n\X = P2X - 5: n\D = 0
			If P2D = 1 Then n\X = P2X + 30: n\D = 1
			n\Y = P2Y + 13
			n\Src = 2
			Angle = Angle + 1
		Next
		BulletTime2 = MilliSecs()
	EndIf
	
	; Flamethrower Player 1
	If Src = 3 Then
		For I = 1 To 50
			n.Bullet = New Bullet
			If P1D = 0 Then n\X = P1X - 5: n\D = 0
			If P1D = 1 Then n\X = P1X + 30: n\D = 1
			n\Y = P1Y + 16
			n\Src = 3
			n\C = Rand(1, 3)
		Next	
	EndIf
	
	; Flamethrower Player 2
	If Src = 4 Then 
		For I = 1 To 50
			n.Bullet = New Bullet
			If P2D = 0 Then n\X = P2X + 5: n\D = 0
			If P2D = 1 Then n\X = P2X + 30: n\D = 1
			n\Y = P2Y + 16
			n\Src = 4
			n\C = Rand(1, 3)
		Next
	EndIf
	
	; Plasma Sword Player 1
	If Src = 5 Then
		n.Bullet = New Bullet
		If P1D = 0 Then n\X = P1X: n\D = 0: n\Frame = 13
		If P1D = 1 Then n\X = P1X: n\D = 1: n\Frame = 0
		n\Y = P1Y - 30
		n\Src = 5
		UsingSword1 = 1
	EndIf
	
	; Plasma Sword Player 2
	If Src = 6 Then
		n.Bullet = New Bullet
		If P2D = 0 Then n\X = P2X: n\D = 0: n\Frame = 13
		If P2D = 1 Then n\X = P2X: n\D = 1: n\Frame = 0
		n\Y = P2Y - 30
		n\Src = 6
		UsingSword2 = 1
	EndIf
	
End Function

Function RenderBullet()
For n.Bullet = Each Bullet
	Del = 0
	
	; Shotgun Spread
	If n\Src = 1 Or n\Src = 2 Then
		If n\D = 0 And n\Angle = 1 Then n\X = n\X - 16
		If n\D = 1 And n\Angle = 1 Then n\X = n\X + 16
	
		If n\D = 0 And n\Angle = 2 Then n\X = n\X - 16: n\Y = n\Y - 4
		If n\D = 1 And n\Angle = 2 Then n\X = n\X + 16: n\Y = n\Y - 4
		
		If n\D = 0 And n\Angle = 3 Then n\X = n\X - 16: n\Y = n\Y + 4
		If n\D = 1 And n\Angle = 3 Then n\X = n\X + 16: n\Y = n\Y + 4
		
		DrawImage Shot, n\X, n\Y
	
		If n\X < 0 Or n\X > 640 Then Del = 1
		
		If ImageRectCollide(Mech, P1X, P1Y, P1Frame, n\X, n\Y, 8, 8) And n\Src = 2 Then
			If p1s = 1 Or p1s = 3 Then P1Life = P1Life - 2: Del = 1
			If P1s = 0 Then SV1 = SV1 - 5: Del = 1
		EndIf
	
		If ImageRectCollide(Mech2, P2X, P2Y, P2Frame, n\X, n\Y, 8, 8) And n\Src = 1 Then
			If p2S = 1 Or p2s = 3 Then P2Life = P2Life - 2: Del = 1
			If P2S = 0 Then SV2 = SV2 - 5: Del = 1
		EndIf		
	EndIf
	
	; Flame Thrower
	If n\Src = 3 Or n\Src = 4 Then
		If n\D = 0 Then n\X = n\X - Rand(8, 16)
		If n\D = 1 Then n\X = n\X + Rand(8, 16)
		n\Y = n\Y + Rand(-4, 4)
		If n\C = 1 Then Color 255, 0, 0
		If n\C = 2 Then Color 255, 255, 0
		If n\C = 3 Then Color 255, 128, 0
		Oval n\X, n\Y, 4, 4
		
		If n\X > P1X + 84 And n\Src = 3 Then Del = 1
		If n\X < p1X - 50 And n\Src = 3 Then Del = 1
		
		If n\X > P2X + 84 And n\Src = 4 Then Del = 1
		If n\X < P2X - 50 And n\Src = 4 Then Del = 1
		
		If ImageRectCollide(Mech, P1X, P1Y, P1Frame, n\X, n\Y, 4, 4) And n\Src = 4 Then
			If p1s = 1 Or p1s = 3 Then P1Life = P1Life - .02: Del = 1
			If P1s = 0 Then SV1 = SV1 - .15: Del = 1
		EndIf
	
		If ImageRectCollide(Mech2, P2X, P2Y, P2Frame, n\X, n\Y, 4, 4) And n\Src = 3 Then
			If p2S = 1 Or p2s = 3 Then P2Life = P2Life - .02: Del = 1
			If P2S = 0 Then SV2 = SV2 - .15: Del = 1
		EndIf
	EndIf
	
	; Plasma Sword
	If n\Src = 5 Or n\Src = 6 Then
		If n\Src = 5 Then
			If n\D = 0 Then n\X = P1X - 30
			If n\D = 1 Then n\X = P1X - 21
			n\Y = P1Y - 30
			DrawImage Sword, n\X, n\Y, n\Frame
			If n\D = 0 Then n\Frame = n\Frame - 1
			If n\D = 1 Then n\Frame = n\Frame + 1
			If n\Frame = 7 Then Del = 1: UsingSword1 = 0
		EndIf
		
		If n\Src = 6 Then
			If n\D = 0 Then n\X = P2X - 30
			If n\D = 1 Then n\X = P2X - 21
			n\Y = P2Y - 30
			DrawImage Sword2, n\X, n\Y, n\Frame
			If n\D = 0 Then n\Frame = n\Frame - 1
			If n\D = 1 Then n\Frame = n\Frame + 1
			If n\Frame = 7 Then Del = 1: UsingSword2 = 0
		EndIf
		
		If ImagesCollide(Mech2, P2X, P2Y, P2Frame, Sword, n\X, n\Y, n\Frame) And n\Src = 5 Then PlaySound Sword2SFX
		If ImagesCollide(Mech, P1X, P1Y, P1Frame, Sword2, n\X, n\Y, n\Frame) And n\Src = 6 Then PlaySound Sword2SFX
		
		If ImagesCollide(Mech, P1X, P1Y, P1Frame, Sword, n\X, n\Y, n\Frame) And n\Src = 6 And n\Frame > 4 And n\Frame < 10 Then
			If P1S = 1 Or P1S = 3 Then P1Life = P1Life - 6: Del = 1
			If P1S = 0 Then SV1 = SV1 - 25: Del = 1
			UsingSword2 = 0
		EndIf
		
		If ImagesCollide(Mech2, P2X, P2Y, P1Frame, Sword, n\X, n\Y, n\Frame) And n\Src = 5 And n\Frame > 4 And n\Frame < 10 Then
			If P2S = 1 Or P2S = 3 Then P2Life = P2Life - 6: Del = 1
			If P2S = 0 Then SV2 = SV2 - 25: Del = 1
			UsingSword1 = 0
		EndIf
		
	EndIf
	
	If Del = 1 Then Delete N
Next
End Function

Function Boost(Src)
If Src = 1 Then 
	If BD = 0 Then 
		For I = 1 To 100
			CreateParticle(1)
		Next
	EndIf

	If BD = 0 BP = BP - 5
	If BD = 0 Then P1Y = P1Y - 8
	If BP = 0 Then BD = 1
	If Not KeyDown(200) Then BD = 1
	If BD = 1 Then P1Y = P1Y + 16
	If P1Y => 217 Then Boosting = 0: P1Y = 217
EndIf

If Src = 2 Then
	If BD2 = 0 Then 
		For I = 1 To 100
			CreateParticle(2)
		Next
	EndIf
	If BD2 = 0 BP2 = BP2 - 5
	If BD2 = 0 Then P2Y = P2Y - 8
	If BP2 = 0 Then BD2 = 1
	If Not JoyDown(2) Then BD2 = 1
	If BD2 = 1 Then P2Y = P2Y + 16
	If P2Y => 217 Then Boosting2 = 0: P2Y = 217
EndIf

End Function

Function CreateParticle(Src)
a.Particle = New Particle
	If Src = 1 Then
	If P1D = 1 Then a\X = P1X + Rand(-2, 2)
	If P1D = 0 Then a\X = P1X + 44 + Rand(-2, 2)
	a\Y = P1Y + 15
	EndIf
	
	If src = 2 Then
	If P2D = 1 Then a\X = P2X + Rand(-2, 2)
	If P2D = 0 Then a\X = P2X + 44 + Rand(-2, 2)
	a\Y = P2Y + 15
	EndIf
	
	a\C = 1
	a\L = Rand(5, 15)
End Function

Function RenderParticle()
For a.Particle = Each Particle
	a\X = a\X + Rand(-2, 2)
	a\Y = a\Y + Rand(-1, 6)
	If a\L < 11 Then a\C = 2
	If a\L < 6 Then a\C = 3
	If a\C = 1 Then Color 255, 255, 255
	If a\C = 2 Then Color 0, 128, 255
	If a\C = 3 Then Color 0, 73, 149
	Rect a\X, a\Y, 1, 1
	a\L =a\L - 1
	If a\L <= 0 Then Delete a
Next
End Function

; *///////////////// Game Over \\\\\\\\\\\\\\\\\*
.Over
FlushKeys()
SetBuffer FrontBuffer()
Cls
SetBuffer BackBuffer()
Cls
Color 255, 255, 255
If Winner = 1 Then Text 1, 1, "Player 1 Wins"
If Winner = 2 Then Text 1, 1, "Player 2 Wins"
Text 1, 15, "Press Enter retry or Escape to Quit"
Flip
.Over2
If KeyHit(28) Then ; Restart
	P1X = 70: P1Y = 217: P1D = 1: P1Frame = 0
	P2X = 270: P2Y = 217: P2D = 0: P2Frame = 9
	X2 = 0: J2 = 0: J2D = 0
	X4 = 200: X5 = 0: P1P = 50: P2P = 270
	X = 200: J = 0: JD = 0: View = 1
	P1S = 1: SV1# = 255: P2S = 1: SV2# = 255
	Timer = MilliSecs(): Press1 = 0: Press2 = 0
	P1Life# = 100: P2Life# = 100: Winner = 0
	BP = 100: BD = 0: Boosting = 0
	Bp2 = 100: BD2 = 1: Boosting2 = 0
	UsingSword1 = 0: UsingSword2 = 0
	BulletTime1 = MilliSecs(): BulletTime2 = MilliSecs()
    P1Weap1 = 0: P1Weap2 = 0: P2Weap1 = 0: P2Weap2 = 0
    CurrentWeap1 = 1: CurrentWeap2 = 1
	Delete Each Bullet ; Delete Types
	Delete Each Particle
	FlushKeys
	Goto Reset
ElseIf KeyHit(1) ; End
	Unload()
Else 
	Goto Over2
EndIf

Function Unload()
FreeImage Mech: FreeImage Logo: FreeImage WeapSel ; Free Images
FreeImage Shot: FreeImage Flame: FreeImage Mech2
FreeImage Back2: FreeImage Sword: FreeImage Sword2

FreeSound ShotgunSFX: FreeSound FlameSFX: FreeSound BoostSFX ; Free Sounds
FreeSound IntroSFX: FreeSound DestroySFX: FreeSound SwordSFX
FreeSound Sword2SFX: FreeSound ShieldON: FreeSound ShieldOFF
FreeSound ArnoldSFX
End
End Function




	